
/**
 * From Chapter 14 of the Horstman text
 *
 */

public class BinarySearcher
{
	private int[] a;
	
	/**
	 * Constructs a BinarySearcher
	 *
	 * @param anArray an array of integers
	 *
	 */
	 
	public BinarySearcher( int[] anArray )
	{
		a = anArray;
	}
	
	/**
	 * Finds a value in the array
	 *
	 * @param v the target search value
	 * @return the index at which the value occurs,
	 * -1 if it is not in the array
	 *
	 */
	
	public int search( int v )
	{
		int low = 0;
		int high = a.length - 1;
		while ( low <= high )
		{
			int mid = (low + high)/2;
			int diff = a[mid] - v;
			if ( diff==0 ) // target found (a[mid] == v)
			   return mid;
			else if ( diff<0 )
			   low = mid+1;
			else
			   high = mid-1;
		}
		return -1;
	}
}
